package com.gic.plug.web;

import com.gic.dubbo.util.DubboContextUtil;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.data.redis.RedisAutoConfiguration;
import org.springframework.boot.autoconfigure.data.redis.RedisRepositoriesAutoConfiguration;
import org.springframework.boot.autoconfigure.quartz.QuartzAutoConfiguration;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.context.annotation.ImportResource;

/**
 * Spring Boot Web 启动类
 *
 * @author zhurz
 */
@SpringBootApplication(
        scanBasePackages = "com.gic",
        exclude = {
                RedisAutoConfiguration.class,
                RedisRepositoriesAutoConfiguration.class,
                QuartzAutoConfiguration.class
        }
)
@ImportResource(value = {
        "classpath*:applicationContext-init.xml",
        "classpath*:dubbo-setting.xml",
        "classpath*:dubbo-gic-webapp-plug.xml",
        "classpath*:spring-interceptor.xml",
        "classpath*:redis-init.xml"
        /*"classpath:web-common-spring.xml"*/
})
public class Main {

    public static void main(String[] args) {
        ConfigurableApplicationContext context = SpringApplication.run(Main.class, args);
        DubboContextUtil.setApplicationContext(context);
    }

}