package com.gic.plug.web.controller;

import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.store.constant.StoreGroupConstant;
import com.gic.store.dto.StoreGroupDTO;
import com.gic.store.service.StoreGroupApiService;
import com.gic.store.utils.storegroup.ChangeListToTree;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author guojx
 * @date 2019/7/12 2:54 PM
 */
@RestController
@RequestMapping("/store-group")
public class StoreGroupController {
    private static final Logger logger = LoggerFactory.getLogger(StoreGroupController.class);

    @Autowired
    private StoreGroupApiService storeGroupApiService;

    @RequestMapping("/list")
    public RestResponse listStoreGroup() {
        StoreGroupDTO dto = new StoreGroupDTO();
        dto.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        List<StoreGroupDTO> list = storeGroupApiService.listStoreGroup(dto).getResult();
        return RestResponse.success(ChangeListToTree.changeListToTreeNotIncludeAllStore(StoreGroupConstant.ALL_STORE_LEVEL, list));
    }
}
