package com.gic.plug.web.controller;

import com.alibaba.fastjson.JSON;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.thirdparty.pic.QQCloudPicUtils;
import com.gic.thirdparty.pic.UploadResult;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.*;

@RestController
public class UploadImgController {
    private Logger logger = LogManager.getLogger(UploadImgController.class);

    @RequestMapping("upload-images")
    public RestResponse uploadImages(HttpServletRequest request) throws IOException {
        MultipartHttpServletRequest multiRequest = (MultipartHttpServletRequest) request;
        Iterator<String> iter = multiRequest.getFileNames();
        java.util.List<Map<String, Object>> picList = new ArrayList<Map<String, Object>>();
        while (iter.hasNext()) {
            String fileName = iter.next();
            List<MultipartFile> list = multiRequest.getMultiFileMap().get(fileName);
            Map<String, Object> map = null;
            for (int i = 0; i < list.size(); i++) {
                MultipartFile mf = list.get(i);
                UploadResult uploadResult = QQCloudPicUtils.uploadLocalPicStream("pic01", "", mf.getBytes());
                logger.info("上传图片结果："+JSON.toJSONString(uploadResult));
                Map<String, Object> pic = new HashMap<>();
                pic.put("fileId", uploadResult.getFileId());
                pic.put("url", uploadResult.getUrl());
                pic.put("downloadUrl", uploadResult.getDownloadUrl());
                picList.add(pic);
            }
        }
        return RestResponse.success(picList);
    }
}
