package com.gic.plug.web.controller.goods;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.contants.SortType;
import com.gic.commons.util.PageHelperUtils;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.goods.api.dto.PropertyDTO;
import com.gic.goods.api.dto.PropertyValueDTO;
import com.gic.goods.api.service.PropertyApiService;
import com.gic.goods.api.service.PropertyValueApiService;
import com.gic.goods.api.util.Constant;
import com.gic.plug.web.vo.goods.GoodsPropertyVO;
import com.gic.plug.web.vo.goods.GoodsPropertyValueVO;

@RestController
public class GoodsPropertyController {

    @Autowired
    private PropertyApiService propertyApiService;

    @Autowired
    private PropertyValueApiService propertyValueApiService;

    @RequestMapping("/property-list")
    public RestResponse propertyList(int pageSize, int currentPage, String search, Long goodsDomainId) {
        List<String> arrayList = new ArrayList<>();
        arrayList.add(Constant.PROPERTY_TYPE_TEXT);
        arrayList.add(Constant.PROPERTY_TYPE_TIME);
        arrayList.add(Constant.PROPERTY_TYPE_CURRENCY);
        arrayList.add(Constant.PROPERTY_TYPE_PERCENT);
        arrayList.add(Constant.PROPERTY_TYPE_NUM);
        arrayList.add(Constant.PROPERTY_TYPE_REAL_NUM);
        ServiceResponse<Page<PropertyDTO>> serviceResponse = propertyApiService.findPropertyExceptType(currentPage, pageSize, goodsDomainId, arrayList,search);
        if (!serviceResponse.isSuccess()) {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
        Page<GoodsPropertyVO> page = PageHelperUtils.changePageToCurrentPage(serviceResponse.getResult(), GoodsPropertyVO.class);
        return RestResponse.success(page);
    }

    @RequestMapping("/property-value-list")
    public RestResponse propertyValueList(int pageSize, int currentPage, String search, Long specPropertyId) {
        ServiceResponse<Page<PropertyValueDTO>> serviceResponse = propertyValueApiService
                .pagePropertyValue(currentPage, pageSize, specPropertyId, search, SortType.sortDescType);
        if (!serviceResponse.isSuccess()) {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
        Page<GoodsPropertyValueVO> page = PageHelperUtils.changePageToCurrentPage(serviceResponse.getResult(), GoodsPropertyValueVO.class);
        return RestResponse.success(page);
    }

}
