package com.gic.store.web.qo.storegroup;

import com.gic.store.constant.StoreGroupConstant;

import javax.validation.constraints.*;
import java.io.Serializable;
import java.util.Date;

/**
 * @author guojx
 * @date 2019/6/27 2:14 PM
 */
public class StoreGroupQO implements Serializable{
    private static final long serialVersionUID = -6732142611051879496L;

    public interface SaveValidView {
    }


    public interface SortValidView {
    }

    public interface RemoveValidView {
    }


    /**
     *
     *
     */
    @NotNull(message = "门店分组ID不能为空", groups = {RemoveValidView.class, SortValidView.class})
    private Integer storeGroupId;

    /**
     * 分组名称
     */
    @NotBlank(message = "名称不能为空", groups = {SaveValidView.class})
    private String storeGroupName;

    /**
     * 父级分组id
     */
    private Integer parentStoreGroupId;

    /**
     *
     */
    private Integer enterpriseId;

    /**
     * 分组层级
     */
    @NotNull(message = "层级不能为空", groups = {SaveValidView.class})
    private Integer groupLevel;

    /**
     * 分组链id
     */
    private String storeGroupChain;

    /**
     * 分组排序
     */
    private Integer sort;

    /**
     * 状态值
     */
    private Integer status;

    /**
     *
     */
    private Date createTime;

    /**
     *
     */
    private Date updateTime;
    /**
     * 是否是默认门店，初始化品牌的时候会建立一条默认门店：未分组门店，1:是 0:否
     */
    private Integer isDefault;
    /**
     * 上移或者下移
     */
    @NotNull(message = "移动标志参数值不能为空", groups = {SortValidView.class})
    @Min(value = StoreGroupConstant.SORT_UP, message = "移动标志参数值错误，小于1", groups = {SortValidView.class})
    @Max(value = StoreGroupConstant.SORT_DOWN, message = "移动标志参数值错误，大于2", groups = {SortValidView.class})
    private Integer upOrDown;

    private boolean isUp;

    public Integer getStoreGroupId() {
        return storeGroupId;
    }

    public void setStoreGroupId(Integer storeGroupId) {
        this.storeGroupId = storeGroupId;
    }

    public String getStoreGroupName() {
        return storeGroupName;
    }

    public void setStoreGroupName(String storeGroupName) {
        this.storeGroupName = storeGroupName;
    }

    public Integer getParentStoreGroupId() {
        return parentStoreGroupId;
    }

    public void setParentStoreGroupId(Integer parentStoreGroupId) {
        this.parentStoreGroupId = parentStoreGroupId;
    }

    public Integer getEnterpriseId() {
        return enterpriseId;
    }

    public void setEnterpriseId(Integer enterpriseId) {
        this.enterpriseId = enterpriseId;
    }

    public Integer getGroupLevel() {
        return groupLevel;
    }

    public void setGroupLevel(Integer groupLevel) {
        this.groupLevel = groupLevel;
    }

    public String getStoreGroupChain() {
        return storeGroupChain;
    }

    public void setStoreGroupChain(String storeGroupChain) {
        this.storeGroupChain = storeGroupChain;
    }

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getIsDefault() {
        return isDefault;
    }

    public void setIsDefault(Integer isDefault) {
        this.isDefault = isDefault;
    }

    public Integer getUpOrDown() {
        return upOrDown;
    }

    public void setUpOrDown(Integer upOrDown) {
        this.upOrDown = upOrDown;
    }

    public boolean isUp() {
        if (upOrDown == StoreGroupConstant.SORT_UP) {
            return true;
        } else {
            return false;
        }
    }
}
