package com.gic.plug.web.strategy.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.CityDTO;
import com.gic.store.dto.ProvinceDTO;
import com.gic.store.service.ProvincesApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class StoreAreaBackImpl implements ScreenBackStrategy {
    @Autowired
    private ProvincesApiService provincesApiService;
    @Override
    public String screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            ServiceResponse<List<CityDTO>> cityResponse = this.provincesApiService.selectAllCity();
            StringBuilder stringBuilder = new StringBuilder(StoreESFieldsEnum.AREAIDS.getDesc()).append(" ");
            stringBuilder.append(ComputeBackUtil.getComputeBack(compute)).append(" ");
            if(cityResponse.isSuccess()){
                List<CityDTO> cityDTOList = cityResponse.getResult();
                if(CollectionUtils.isNotEmpty(cityDTOList)){
                    String[] valueArr = value.split(" ");
                    for(CityDTO cityDTO : cityDTOList){
                        for(String s : valueArr){
                            if(s.equals(cityDTO.getCityId())){
                                String provinceName = "";
                                ServiceResponse<ProvinceDTO> provinceById = this.provincesApiService.getProvinceById(cityDTO.getProvinceId());
                                if(provinceById.isSuccess()){
                                    provinceName = provinceById.getResult().getProvinceName();
                                }
                                stringBuilder.append("【").append(cityDTO.getCityName()).append("-").append(provinceName).append("】");
                            }
                        }
                    }
                }
            }
            return stringBuilder.toString();
        }
        return null;
    }
}
