package com.gic.plug.web.strategy.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreBrandDTO;
import com.gic.store.service.StoreBrandApiService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
public class StoreBrandBackImpl implements ScreenBackStrategy {
    @Autowired
    private StoreBrandApiService storeBrandApiService;
    @Override
    public String screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            StringBuilder stringBuilder = new StringBuilder(StoreESFieldsEnum.STOREBRANDIDLIST.getDesc()).append(" ");
            stringBuilder.append(ComputeBackUtil.getComputeBack(compute)).append(" ");
            List<Integer> storeBrandIdList = new ArrayList<>();
            String[] valueArr = value.split(" ");
            for(String s : valueArr){
                storeBrandIdList.add(Integer.valueOf(s));
            }
            ServiceResponse<List<StoreBrandDTO>> listServiceResponse = this.storeBrandApiService.listStoreBrandByIds(storeBrandIdList);
            if(listServiceResponse.isSuccess()){
                List<StoreBrandDTO> list = listServiceResponse.getResult();
                for(StoreBrandDTO storeBrandDTO : list){
                    stringBuilder.append("【").append(storeBrandDTO.getStoreBrandName()).append("】").append(" ");
                }
            }
            return stringBuilder.toString();
        }
        return null;
    }
}
