package com.gic.plug.web.strategy.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreGroupDTO;
import com.gic.store.service.StoreGroupApiService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
public class StoreGroupBackImpl implements ScreenBackStrategy {
    @Autowired
    private StoreGroupApiService storeGroupApiService;
    @Override
    public String screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            StringBuilder stringBuilder = new StringBuilder(StoreESFieldsEnum.STOREGROUPIDLIST.getDesc()).append(" ");
            stringBuilder.append(ComputeBackUtil.getComputeBack(compute)).append(" ");
            String[] valueArr = value.split(" ");
            List<Integer> storeGroupIdList = new ArrayList<>();
            for(String s : valueArr){
                storeGroupIdList.add(Integer.valueOf(s));
            }
            ServiceResponse<List<StoreGroupDTO>> listServiceResponse = this.storeGroupApiService.listStoreGroupByIds(storeGroupIdList, enterpriseId);
            if(listServiceResponse.isSuccess()){
                if(listServiceResponse.getResult() != null){
                    for(StoreGroupDTO storeGroupDTO : listServiceResponse.getResult()){
                        stringBuilder.append("【").append(storeGroupDTO.getStoreGroupName()).append("】").append(" ");
                    }
                }
            }
            return stringBuilder.toString();
        }
        return null;
    }
}
