package com.gic.plug.web.strategy.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreRegionDTO;
import com.gic.store.service.StoreRegionApiService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
public class StoreRegionBackImpl implements ScreenBackStrategy {
    @Autowired
    private StoreRegionApiService storeRegionApiService;
    @Override
    public String screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            StringBuilder stringBuilder = new StringBuilder(StoreESFieldsEnum.REGIONID.getDesc()).append(" ");
            stringBuilder.append(ComputeBackUtil.getComputeBack(compute)).append(" ");
            String[] valueArr = value.split(" ");
            List<Integer> storeRegionIdList = new ArrayList<>();
            for(String s : valueArr){
                storeRegionIdList.add(Integer.valueOf(s));
            }
            ServiceResponse<List<StoreRegionDTO>> listServiceResponse = this.storeRegionApiService.listStoreRegionByIds(enterpriseId, storeRegionIdList);
            if(listServiceResponse.isSuccess()){
                if(listServiceResponse.getResult() != null){
                    for(StoreRegionDTO storeRegionDTO : listServiceResponse.getResult()){
                        stringBuilder.append("【").append(storeRegionDTO.getRegionName()).append("】").append(" ");
                    }
                }
            }
            return stringBuilder.toString();
        }
        return null;
    }
}
